/*
 * DDS.c
 *
 *  Created on: Dec 12, 2022
 *      Author: piter
 */

#include "DDS.h"
#include <math.h>

typedef enum DDS_ErrorReason
{
	DDS_Error_UnhandledMode,
	DDS_Error_InitError,
	DDS_Error_GenericError
}DDS_ErrorReason;

volatile const uint16_t sine_lut[DDS_SINE_LUT_LEN]= {
		32768,32969,33170,33371,33572,33774,33975,34176,
		34377,34578,34779,34980,35180,35381,35582,35782,
		35982,36183,36383,36583,36782,36982,37182,37381,
		37580,37779,37978,38177,38375,38573,38771,38969,
		39166,39364,39561,39757,39954,40150,40346,40542,
		40737,40932,41127,41321,41515,41709,41903,42096,
		42288,42481,42673,42864,43056,43247,43437,43627,
		43817,44006,44195,44383,44571,44759,44946,45133,
		45319,45504,45690,45874,46058,46242,46425,46608,
		46790,46972,47153,47333,47513,47693,47872,48050,
		48228,48405,48582,48758,48933,49108,49282,49455,
		49628,49800,49972,50143,50313,50483,50652,50820,
		50988,51155,51321,51487,51651,51815,51979,52142,
		52303,52465,52625,52785,52944,53102,53259,53416,
		53572,53727,53881,54035,54188,54339,54491,54641,
		54790,54939,55087,55234,55380,55525,55669,55813,
		55955,56097,56238,56378,56517,56655,56793,56929,
		57065,57199,57333,57466,57597,57728,57858,57987,
		58115,58242,58368,58493,58618,58741,58863,58984,
		59104,59224,59342,59459,59575,59691,59805,59918,
		60030,60141,60251,60360,60468,60575,60681,60786,
		60890,60993,61095,61195,61295,61393,61491,61587,
		61682,61776,61869,61961,62052,62142,62230,62318,
		62404,62490,62574,62657,62739,62820,62899,62978,
		63055,63131,63206,63280,63353,63425,63495,63565,
		63633,63700,63766,63830,63894,63956,64017,64077,
		64136,64193,64250,64305,64359,64412,64464,64514,
		64563,64611,64658,64704,64748,64791,64834,64874,
		64914,64952,64990,65025,65060,65094,65126,65157,
		65187,65216,65243,65269,65294,65318,65340,65362,
		65382,65401,65418,65435,65450,65464,65476,65488,
		65498,65507,65515,65521,65526,65530,65533,65535,
		65535,65534,65532,65528,65524,65518,65511,65503,
		65493,65482,65470,65457,65442,65427,65410,65391,
		65372,65351,65329,65306,65282,65256,65230,65201,
		65172,65142,65110,65077,65043,65008,64971,64933,
		64894,64854,64813,64770,64726,64681,64635,64587,
		64539,64489,64438,64386,64332,64278,64222,64165,
		64107,64047,63987,63925,63862,63798,63733,63666,
		63599,63530,63460,63389,63317,63244,63169,63093,
		63017,62939,62860,62779,62698,62616,62532,62447,
		62361,62274,62186,62097,62007,61915,61823,61729,
		61635,61539,61442,61344,61245,61145,61044,60942,
		60838,60734,60629,60522,60415,60306,60196,60086,
		59974,59862,59748,59633,59517,59401,59283,59164,
		59044,58924,58802,58679,58556,58431,58305,58179,
		58051,57923,57793,57663,57532,57399,57266,57132,
		56997,56861,56724,56586,56448,56308,56168,56026,
		55884,55741,55597,55452,55307,55160,55013,54865,
		54716,54566,54415,54264,54111,53958,53804,53650,
		53494,53338,53181,53023,52864,52705,52545,52384,
		52223,52060,51897,51734,51569,51404,51238,51071,
		50904,50736,50568,50398,50228,50058,49886,49714,
		49542,49369,49195,49020,48845,48670,48493,48317,
		48139,47961,47782,47603,47424,47243,47062,46881,
		46699,46517,46334,46150,45966,45782,45597,45412,
		45226,45039,44852,44665,44477,44289,44101,43912,
		43722,43532,43342,43151,42960,42769,42577,42385,
		42192,41999,41806,41612,41418,41224,41029,40835,
		40639,40444,40248,40052,39856,39659,39462,39265,
		39068,38870,38672,38474,38276,38077,37879,37680,
		37481,37281,37082,36882,36683,36483,36283,36083,
		35882,35682,35481,35281,35080,34879,34678,34477,
		34276,34075,33874,33673,33472,33271,33069,32868,
		32667,32466,32264,32063,31862,31661,31460,31259,
		31058,30857,30656,30455,30254,30054,29853,29653,
		29452,29252,29052,28852,28653,28453,28254,28054,
		27855,27656,27458,27259,27061,26863,26665,26467,
		26270,26073,25876,25679,25483,25287,25091,24896,
		24700,24506,24311,24117,23923,23729,23536,23343,
		23150,22958,22766,22575,22384,22193,22003,21813,
		21623,21434,21246,21058,20870,20683,20496,20309,
		20123,19938,19753,19569,19385,19201,19018,18836,
		18654,18473,18292,18111,17932,17753,17574,17396,
		17218,17042,16865,16690,16515,16340,16166,15993,
		15821,15649,15477,15307,15137,14967,14799,14631,
		14464,14297,14131,13966,13801,13638,13475,13312,
		13151,12990,12830,12671,12512,12354,12197,12041,
		11885,11731,11577,11424,11271,11120,10969,10819,
		10670,10522,10375,10228,10083,9938,9794,9651,
		9509,9367,9227,9087,8949,8811,8674,8538,
		8403,8269,8136,8003,7872,7742,7612,7484,
		7356,7230,7104,6979,6856,6733,6611,6491,
		6371,6252,6134,6018,5902,5787,5673,5561,
		5449,5339,5229,5120,5013,4906,4801,4697,
		4593,4491,4390,4290,4191,4093,3996,3900,
		3806,3712,3620,3528,3438,3349,3261,3174,
		3088,3003,2919,2837,2756,2675,2596,2518,
		2442,2366,2291,2218,2146,2075,2005,1936,
		1869,1802,1737,1673,1610,1548,1488,1428,
		1370,1313,1257,1203,1149,1097,1046,996,
		948,900,854,809,765,722,681,641,
		602,564,527,492,458,425,393,363,
		334,305,279,253,229,206,184,163,
		144,125,108,93,78,65,53,42,
		32,24,17,11,7,3,1,0,
		0,2,5,9,14,20,28,37,
		47,59,71,85,100,117,134,153,
		173,195,217,241,266,292,319,348,
		378,409,441,475,510,545,583,621,
		661,701,744,787,831,877,924,972,
		1021,1071,1123,1176,1230,1285,1342,1399,
		1458,1518,1579,1641,1705,1769,1835,1902,
		1970,2040,2110,2182,2255,2329,2404,2480,
		2557,2636,2715,2796,2878,2961,3045,3131,
		3217,3305,3393,3483,3574,3666,3759,3853,
		3948,4044,4142,4240,4340,4440,4542,4645,
		4749,4854,4960,5067,5175,5284,5394,5505,
		5617,5730,5844,5960,6076,6193,6311,6431,
		6551,6672,6794,6917,7042,7167,7293,7420,
		7548,7677,7807,7938,8069,8202,8336,8470,
		8606,8742,8880,9018,9157,9297,9438,9580,
		9722,9866,10010,10155,10301,10448,10596,10745,
		10894,11044,11196,11347,11500,11654,11808,11963,
		12119,12276,12433,12591,12750,12910,13070,13232,
		13393,13556,13720,13884,14048,14214,14380,14547,
		14715,14883,15052,15222,15392,15563,15735,15907,
		16080,16253,16427,16602,16777,16953,17130,17307,
		17485,17663,17842,18022,18202,18382,18563,18745,
		18927,19110,19293,19477,19661,19845,20031,20216,
		20402,20589,20776,20964,21152,21340,21529,21718,
		21908,22098,22288,22479,22671,22862,23054,23247,
		23439,23632,23826,24020,24214,24408,24603,24798,
		24993,25189,25385,25581,25778,25974,26171,26369,
		26566,26764,26962,27160,27358,27557,27756,27955,
		28154,28353,28553,28753,28952,29152,29352,29553,
		29753,29953,30154,30355,30555,30756,30957,31158,
		31359,31560,31761,31963,32164,32365,32566,32768,};

volatile const uint16_t triangle_lut[DDS_TRIANGLE_LUT_LEN]= {
		128,256,384,512,641,769,897,1025,
		1153,1281,1409,1537,1666,1794,1922,2050,
		2178,2306,2434,2562,2691,2819,2947,3075,
		3203,3331,3459,3587,3716,3844,3972,4100,
		4228,4356,4484,4612,4741,4869,4997,5125,
		5253,5381,5509,5637,5766,5894,6022,6150,
		6278,6406,6534,6662,6791,6919,7047,7175,
		7303,7431,7559,7687,7816,7944,8072,8200,
		8328,8456,8584,8712,8840,8969,9097,9225,
		9353,9481,9609,9737,9865,9994,10122,10250,
		10378,10506,10634,10762,10890,11019,11147,11275,
		11403,11531,11659,11787,11915,12044,12172,12300,
		12428,12556,12684,12812,12940,13069,13197,13325,
		13453,13581,13709,13837,13965,14094,14222,14350,
		14478,14606,14734,14862,14990,15119,15247,15375,
		15503,15631,15759,15887,16015,16144,16272,16400,
		16528,16656,16784,16912,17040,17169,17297,17425,
		17553,17681,17809,17937,18065,18193,18322,18450,
		18578,18706,18834,18962,19090,19218,19347,19475,
		19603,19731,19859,19987,20115,20243,20372,20500,
		20628,20756,20884,21012,21140,21268,21397,21525,
		21653,21781,21909,22037,22165,22293,22422,22550,
		22678,22806,22934,23062,23190,23318,23447,23575,
		23703,23831,23959,24087,24215,24343,24472,24600,
		24728,24856,24984,25112,25240,25368,25497,25625,
		25753,25881,26009,26137,26265,26393,26521,26650,
		26778,26906,27034,27162,27290,27418,27546,27675,
		27803,27931,28059,28187,28315,28443,28571,28700,
		28828,28956,29084,29212,29340,29468,29596,29725,
		29853,29981,30109,30237,30365,30493,30621,30750,
		30878,31006,31134,31262,31390,31518,31646,31775,
		31903,32031,32159,32287,32415,32543,32671,32800,
		32928,33056,33184,33312,33440,33568,33696,33825,
		33953,34081,34209,34337,34465,34593,34721,34850,
		34978,35106,35234,35362,35490,35618,35746,35874,
		36003,36131,36259,36387,36515,36643,36771,36899,
		37028,37156,37284,37412,37540,37668,37796,37924,
		38053,38181,38309,38437,38565,38693,38821,38949,
		39078,39206,39334,39462,39590,39718,39846,39974,
		40103,40231,40359,40487,40615,40743,40871,40999,
		41128,41256,41384,41512,41640,41768,41896,42024,
		42153,42281,42409,42537,42665,42793,42921,43049,
		43178,43306,43434,43562,43690,43818,43946,44074,
		44202,44331,44459,44587,44715,44843,44971,45099,
		45227,45356,45484,45612,45740,45868,45996,46124,
		46252,46381,46509,46637,46765,46893,47021,47149,
		47277,47406,47534,47662,47790,47918,48046,48174,
		48302,48431,48559,48687,48815,48943,49071,49199,
		49327,49456,49584,49712,49840,49968,50096,50224,
		50352,50481,50609,50737,50865,50993,51121,51249,
		51377,51506,51634,51762,51890,52018,52146,52274,
		52402,52530,52659,52787,52915,53043,53171,53299,
		53427,53555,53684,53812,53940,54068,54196,54324,
		54452,54580,54709,54837,54965,55093,55221,55349,
		55477,55605,55734,55862,55990,56118,56246,56374,
		56502,56630,56759,56887,57015,57143,57271,57399,
		57527,57655,57784,57912,58040,58168,58296,58424,
		58552,58680,58809,58937,59065,59193,59321,59449,
		59577,59705,59834,59962,60090,60218,60346,60474,
		60602,60730,60859,60987,61115,61243,61371,61499,
		61627,61755,61883,62012,62140,62268,62396,62524,
		62652,62780,62908,63037,63165,63293,63421,63549,
		63677,63805,63933,64062,64190,64318,64446,64574,
		64702,64830,64958,65087,65215,65343,65471,65535,
		65471,65343,65215,65087,64958,64830,64702,64574,
		64446,64318,64190,64062,63933,63805,63677,63549,
		63421,63293,63165,63037,62908,62780,62652,62524,
		62396,62268,62140,62012,61883,61755,61627,61499,
		61371,61243,61115,60987,60859,60730,60602,60474,
		60346,60218,60090,59962,59834,59705,59577,59449,
		59321,59193,59065,58937,58809,58680,58552,58424,
		58296,58168,58040,57912,57784,57655,57527,57399,
		57271,57143,57015,56887,56759,56630,56502,56374,
		56246,56118,55990,55862,55734,55605,55477,55349,
		55221,55093,54965,54837,54709,54580,54452,54324,
		54196,54068,53940,53812,53684,53555,53427,53299,
		53171,53043,52915,52787,52659,52530,52402,52274,
		52146,52018,51890,51762,51634,51506,51377,51249,
		51121,50993,50865,50737,50609,50481,50352,50224,
		50096,49968,49840,49712,49584,49456,49327,49199,
		49071,48943,48815,48687,48559,48431,48302,48174,
		48046,47918,47790,47662,47534,47406,47277,47149,
		47021,46893,46765,46637,46509,46381,46252,46124,
		45996,45868,45740,45612,45484,45356,45227,45099,
		44971,44843,44715,44587,44459,44331,44202,44074,
		43946,43818,43690,43562,43434,43306,43178,43049,
		42921,42793,42665,42537,42409,42281,42153,42024,
		41896,41768,41640,41512,41384,41256,41128,40999,
		40871,40743,40615,40487,40359,40231,40103,39974,
		39846,39718,39590,39462,39334,39206,39078,38949,
		38821,38693,38565,38437,38309,38181,38053,37924,
		37796,37668,37540,37412,37284,37156,37028,36899,
		36771,36643,36515,36387,36259,36131,36003,35874,
		35746,35618,35490,35362,35234,35106,34978,34850,
		34721,34593,34465,34337,34209,34081,33953,33825,
		33696,33568,33440,33312,33184,33056,32928,32800,
		32671,32543,32415,32287,32159,32031,31903,31775,
		31646,31518,31390,31262,31134,31006,30878,30750,
		30621,30493,30365,30237,30109,29981,29853,29725,
		29596,29468,29340,29212,29084,28956,28828,28700,
		28571,28443,28315,28187,28059,27931,27803,27675,
		27546,27418,27290,27162,27034,26906,26778,26650,
		26521,26393,26265,26137,26009,25881,25753,25625,
		25497,25368,25240,25112,24984,24856,24728,24600,
		24472,24343,24215,24087,23959,23831,23703,23575,
		23447,23318,23190,23062,22934,22806,22678,22550,
		22422,22293,22165,22037,21909,21781,21653,21525,
		21397,21268,21140,21012,20884,20756,20628,20500,
		20372,20243,20115,19987,19859,19731,19603,19475,
		19347,19218,19090,18962,18834,18706,18578,18450,
		18322,18193,18065,17937,17809,17681,17553,17425,
		17297,17169,17040,16912,16784,16656,16528,16400,
		16272,16144,16015,15887,15759,15631,15503,15375,
		15247,15119,14990,14862,14734,14606,14478,14350,
		14222,14094,13965,13837,13709,13581,13453,13325,
		13197,13069,12940,12812,12684,12556,12428,12300,
		12172,12044,11915,11787,11659,11531,11403,11275,
		11147,11019,10890,10762,10634,10506,10378,10250,
		10122,9994,9865,9737,9609,9481,9353,9225,
		9097,8969,8840,8712,8584,8456,8328,8200,
		8072,7944,7816,7687,7559,7431,7303,7175,
		7047,6919,6791,6662,6534,6406,6278,6150,
		6022,5894,5766,5637,5509,5381,5253,5125,
		4997,4869,4741,4612,4484,4356,4228,4100,
		3972,3844,3716,3587,3459,3331,3203,3075,
		2947,2819,2691,2562,2434,2306,2178,2050,
		1922,1794,1666,1537,1409,1281,1153,1025,
		897,769,641,512,384,256,128,0};

static void _DDS_ErrorHandler(DDS_Instance_t* instPtr, DDS_ErrorReason reason);
static uint16_t _DDS_CalculateSine(DDS_Instance_t* instPtr);
static uint16_t _DDS_CalculateTriangle(DDS_Instance_t* instPtr);


void DDS_Init(DDS_Instance_t* instPtr)
{
	/* Params assertion */
 	if ((instPtr->outFreq == 0) ||
 		(instPtr->sampleFreq == 0)||
		(instPtr->initPhase < 0 || instPtr->initPhase > DDS_SINE_LUT_LEN))
 	{
 		_DDS_ErrorHandler(instPtr, DDS_Error_InitError);
 	}

	instPtr->phaseAcumulator = instPtr->initPhase;
	instPtr->phaseStep = 0;

	DDS_Set_OutputFrequency(instPtr, instPtr->outFreq);
}

void DDS_Set_OutputFrequency(DDS_Instance_t* instPtr, uint32_t outFreq)
{
	instPtr->outFreq = outFreq;

	/* ---- | Calculate phase step |----*/
	switch (instPtr->shape)
	{
		case DDS_Shape_Sine:
			instPtr->phaseStep = DDS_SINE_LUT_LEN;
			instPtr->phaseStep *= (float)(instPtr->outFreq) / (float)(instPtr->sampleFreq);
			break;

		case DDS_Shape_Triangle:
			instPtr->phaseStep = DDS_TRIANGLE_LUT_LEN;
			instPtr->phaseStep *= (float)(instPtr->outFreq) / (float)(instPtr->sampleFreq);
			break;

		default:
			_DDS_ErrorHandler(instPtr, DDS_Error_UnhandledMode);
	}

	/* ------| Calculate sinc correction coefficient | ----- */
	static float corrCoeff = 0;
	if (instPtr->useSincCorrection == false)
	{
		instPtr->sincCorrectionCoeff = 1;
	}

	else
	{
		corrCoeff = M_PI * (float)(instPtr->outFreq) / instPtr->sampleFreq;
		corrCoeff /= sinf(M_PI * (float)(instPtr->outFreq) / instPtr->sampleFreq);
		corrCoeff = fabsf(corrCoeff);

		instPtr->sincCorrectionCoeff = corrCoeff;
	}
}


uint16_t DDS_Calculate(DDS_Instance_t* instPtr)
{
	switch (instPtr->shape)
	{
		case DDS_Shape_Sine:
			return _DDS_CalculateSine(instPtr);
			break;

		case DDS_Shape_Triangle:
			return _DDS_CalculateTriangle(instPtr);
			break;

		default:
			_DDS_ErrorHandler(instPtr, DDS_Error_UnhandledMode);
	}

	return 0;
}

static uint16_t _DDS_CalculateSine(DDS_Instance_t* instPtr)
{
	static float result;

	instPtr->phaseAcumulator += instPtr->phaseStep;

	if (instPtr->phaseAcumulator >= DDS_SINE_LUT_LEN)
		instPtr->phaseAcumulator -= DDS_SINE_LUT_LEN;

	result = sine_lut[(uint16_t)instPtr->phaseAcumulator] - DDS_SINE_LUT_HALF_VAL;
	result *= instPtr->amp; 	// Scale basing on amplitude parameter

	/*----| Apply sinc amplitude correction |----*/
	if (instPtr->useSincCorrection)
		result *= instPtr->sincCorrectionCoeff;

	result += DDS_SINE_LUT_HALF_VAL;

	if (result > UINT16_MAX)
		result = UINT16_MAX;

	else if (result < 0)
		result = 0;

	return (uint16_t)result;
}

static uint16_t _DDS_CalculateTriangle(DDS_Instance_t* instPtr)
{
	static float result;

	instPtr->phaseAcumulator += instPtr->phaseStep;

	if (instPtr->phaseAcumulator >= DDS_TRIANGLE_LUT_LEN)
		instPtr->phaseAcumulator -= DDS_TRIANGLE_LUT_LEN;

	result = triangle_lut[(uint16_t)instPtr->phaseAcumulator] - DDS_TRIANGLE_LUT_HALF_VAL;
	result *= instPtr->amp; 	// Scale basing on amplitude parameter

	/*----| Apply sinc amplitude correction |----*/
	if (instPtr->useSincCorrection)
		result *= instPtr->sincCorrectionCoeff;

	result += DDS_TRIANGLE_LUT_HALF_VAL;

	if (result > UINT16_MAX)
		result = UINT16_MAX;

	else if (result < 0)
		result = 0;

	return (uint16_t)result;
}

static void _DDS_ErrorHandler(DDS_Instance_t* instPtr, DDS_ErrorReason reason)
{
	(void)(instPtr);
	(void)(reason);

	while (1)
	{

	}
}

